/*----------------------------------------------------------------------------------
 * Synthesizer header file
 *
 * Created September 1, 2008 by James Patchell
 * Copyright (c) 2008 by James Patchell
 *
 *----------------------------------------------------------------------------------*/

#ifndef SYNTH__H
#define SYNTH__H

typedef struct _fltparams FILTPARAMS;

struct _fltparams {
	unsigned short Freq;
	unsigned short Q;
};

typedef struct _evparams_a_d EV_A_D;
typedef struct _evparams_s_r EV_S_R;

struct _evparams_a_d {
	unsigned short Attack;
	unsigned short Decay;
};

struct _evparams_s_r {
	unsigned short Sustain;
	unsigned short Release;
};

typedef struct _debugregs SYNTH_DEBUG;

struct _debugregs {
	unsigned short OSC;
	unsigned short EV1;
	unsigned short EV2;
	unsigned short FILT;
	unsigned short VCA;
	unsigned short Channel;
};

#define SYNTH_CONTROL_REG		*((volatile unsigned char *)0xf020)
#define SYNTH_CONTROL_REG_P		((volatile unsigned char *)0xf020)

#define SYNTH_CR_SYNTH_EN	(0)		/*!< Control Register, Enable Synth Bit	*/

#define SYNTH_OSC_FREQ			*((volatile unsigned long *)0x8000)
#define SYNTH_OSC_FREQ_P		((volatile unsigned long *)0x8000)

#define SYNTH_FLT_PARAMS		*((volatile FILTPARAMS *)0x8800)
#define SYNTH_FLT_PARAMS_P		((volatile FILTPARAMS *)0x8800)

#define SYNTH_EV1_AD_PARAMS		*((volatile EV_A_D *)0x9000)
#define SYNTH_EV1_SR_PARAMS		*((volatile EV_S_R *)0x9800)
#define SYNTH_EV2_AD_PARAMS		*((volatile EV_A_D *)0xa000)
#define SYNTH_EV2_SR_PARAMS		*((volatile EV_S_R *)0xa800)

#define SYNTH_EV1_AD_PARAMS_P	((volatile EV_A_D *)0x9000)
#define SYNTH_EV1_SR_PARAMS_P	((volatile EV_S_R *)0x9800)
#define SYNTH_EV2_AD_PARAMS_P	((volatile EV_A_D *)0xa000)
#define SYNTH_EV2_SR_PARAMS_P	((volatile EV_S_R *)0xa800)

#define SYNTH_EV1_CSR_P			((volatile unsigned char *)0xb000)
#define SYNTH_EV2_CSR_P			((volatile unsigned char *)0xb200)

#define SYNTH_CMDREG			*((volatile char *)0xf006)
#define SYNTH_SINGLE_STEP		(0)

#define SYNTH_DEBUG_DATA		*((volatile unsigned short *)0xf090)
#define SYNTH_DEBUG_DATA_P		((volatile unsigned short *)0xf090)

//-----------------------------------------
// function prototypes
//-----------------------------------------

extern void SetOscFreq(unsigned short n, unsigned long f);
extern unsigned long GetOscFreq(unsigned short n);
extern void EnableSynth(unsigned char e);


#endif
