/*@A (C) 1992 Allen I. Holub                                                */
#include "video.h"
#include "termlib.h"
//#include "vbios.h"


static int	Row = 0;	/* Cursor Row	 */
static int	Col = 0;	/* Cursor Column */



/*----------------------------------------------------------------------*/
/* Move cursor to (Row, Col) 						*/

//#define fix_cur() _Vbios( SET_POSN, 0, 0, 0, (Row << 8) | Col , "ax" )
#define fix_cur()

/*----------------------------------------------------------------------*/

void	dv_putc( int c, int attrib )
{
    /* Write a single character to the screen with the indicated  attribute.
     * The following are special:
     *
     *	\0	ignored
     *	\f	clear screen and home cursor
     *	\n	to left edge of next line
     *	\r	to left edge of current line
     *	\b	one character to left (non-destructive)
     *
     * The screen will scroll up if you go past the bottom line. Characters
     * that go beyond the end of the current line wrap around to the next line.
     */
    switch( c )
    {
    case 0:	break;				/* Ignore ASCII NULL's */

    case '\f':
			dv_clrs( attrib );
		    Row = Col = 0;
		    break;

    case '\n':
		if( ++Row >= NUMROWS )
		{
		    dv_scroll_line(0,79,0,24, 'u', NORMAL );
		    Row = NUMROWS-1 ;
		}
						/* Fall through to '\r' */
    case '\r':	
		Col = 0;
		break;

    case '\b':	if( --Col < 0 )
		    Col = 0;
		break;

    default :
//		l = sprintf(s,"ROW = %d  COL= %d Char = %c\r\n",Row,Col,c);
//		RWrite(pR0,s,l);

		SCREEN[ Row ][ Col ].letter    = c      ;
		SCREEN[ Row ][ Col ].attribute = attrib ;
		if( ++Col >= NUMCOLS )
		{
		    Col = 0;
		    if( ++Row >= NUMROWS )
		    {
			dv_scroll_line(0,79,0,24, 'u', NORMAL );
			Row = NUMROWS-1 ;
		    }
		}
		break;
    }
    fix_cur();
}

/*----------------------------------------------------------------------*/

void dv_ctoyx(int y,int x )
{ 		       /* Position the cursor at the indicated row and column */
    Row = y;
    Col = x;

    fix_cur();
}

/*----------------------------------------------------------------------*/

void	dv_getyx(int *rowp,int *colp )
{ 	               /* Modify *rowp and *colp to hold the cursor position. */
    *rowp = Row;
    *colp = Col;
}

/*----------------------------------------------------------------------*/

int	dv_incha(void) 		/* Get character & attribute from screen. */
{
    return  (int)( VSCREEN[ Row ][ Col ] );
}

void dv_outcha(int c)	 	/* Write char. & attrib. w/o moving cursor. */
{
    *VSCREEN[ Row ][ Col ] = c ;
}

void  dv_replace(int c)		/* Write char. only w/o moving cursor */
{
    SCREEN[ Row ][ Col ].letter = c ;
}

void dv_putcyx(int y,int x,int c,int a)
{
    SCREEN[ y ][ x ].letter = (char)c ;
	SCREEN[ y ][ x ].attribute = (char)a ;
}


