/*@A (C) 1992 Allen I. Holub                                                */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "curses.h"
#include "termlib.h"
#include "video.h"


/* GLUE.C	This file glues the curses package to either the video-
 *		BIOS functions or to the direct-video functions.
 */

#if (!defined(R) && !defined(V))
#	define AUTOSELECT
#endif

//#pragma comment(exestr,"IBM-CURSES (C)" __DATE__ "Allen I. Holub. All rights reserved.")

//#pragma message( "/* Compiling for direct-video access */" )

void cmove(WINDOW *w, int y,int x)
{
    w->dvRow = y;
    w->dvCol = x;
}

void curpos(WINDOW *w, int *yp,int *xp)
{
	*yp = w->dvRow;
	*xp = w->dvCol;			
}

void replace(WINDOW *w,int c)
{
    SCREEN[ w->dvRow ][ w->dvCol ].letter = c ;
}

void doscroll(int l,int r,int t,int b,int a,int at)
{
	dv_scroll  (l,r,t,b,a,at);
}

int inchar(void)	     	   
{
	return dv_incha   ( ) & 0xff;		
}

int incha(void)			   
{
	return dv_incha( );			
}

void outc(WINDOW *w, int c,int attrib)
{
	SCREEN[ w->dvRow ][ w->dvCol ].letter    = c      ;
	SCREEN[ w->dvRow ][ w->dvCol ].attribute = attrib ;
	if( ++w->dvCol >= NUMCOLS )
	{
	    w->dvCol = 0;
	    if( ++w->dvRow >= NUMROWS )
	    {
			dv_scroll_line(0,NUMCOLS-1,0,NUMCOLS-1, 'u', NORMAL );
			w->dvRow = NUMROWS-1 ;
	    }
	}
}

SBUF *savescr(int l,int r,int t,int b)
{
	return dv_save(l,r,t,b);		
}

SBUF *restore(SBUF *b)
{
	return dv_restore (b);			
}

void freescr(SBUF *p)
{
	dv_freesbuf(p);			
}

void clr_region(int l,int r,int t,int b,int attrib) 
{
	dv_clr_region(l,r,t,b,attrib);	
}

void DisplayAttrib( int * nC, int *nR)
{
	dv_screen_attrib(nC, nR);
}

int init( void )						/* Initialize */
{
    if( !dv_init() )
    {
//	fprintf(stderr, "MGA or CGA in 80-column text mode required\n");
//	exit( 1 );
    }
    return 1;
}

int is_direct(void)
{
	return 1;
};


