/*****************************************************
** VGA display Driver
******************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include "task.h"
#include "display.h"

ECB VgaSem;

void EnableVGAIrq(void)
{
	EIMSK |= BIT(INT5);
}

void DisableVGAIrq(void)
{
	EIMSK &= ~BIT(INT5);
}

void INT5_vect(void) __attribute__ ((naked));
void INT5_vect(void)
{
	SAVE_IRQ();
	++InterruptCount;
	EIFR = BIT(INT5);
	VGA_CONTROL_STATUS = 0x02;	//clear interrupt
	PostSemaphoreIrq(&VgaSem,0);
	ExitInterrupt();
	RESTORE_IRQ();
}

void InitVGA(void)
{
	int i;
	volatile unsigned short *pI;

	for(i=0,pI = VGA_CHARMEM_P ;i< (80*60);++i)
	{
		*pI++ = ' ' | FG(WHITE) | BG(BLACK);
	}
	i = 0;
	volatile unsigned char *pL = VGA_COLOR_LUT_P;
	*pL++ = (BLACK << 3) | BLACK;
	*pL++ = (RED << 3) | RED;
	*pL++ = (GREEN << 3) | GREEN;
	*pL++ = (YELLOW << 3) | YELLOW;
	*pL++ = (BLUE << 3) | BLUE;
	*pL++ = (VIOLET << 3) | VIOLET;
	*pL++ = (CYAN << 3) | CYAN;
	*pL++ = (WHITE << 3) | WHITE;
	CreateSemaphore(&VgaSem,0,SEMAPHORE_MODE_BLOCKING,"VgaSem");
}


