#include "io.h"
#include <ctype.h>
#include <stdlib.h>
#include "utils.h"

char MakeHex(char v)
{
	if(v > 9)
		v += 'A' - 10;
	else
		v += '0';
	return v;
}

int CharToHex(char v,char *s,char c)
{
	int i = 0;

	s[i++] = MakeHex((v >> 4) & 0x0f);
	s[i++] = MakeHex(v & 0x0f);
	if(c)
		s[i++] = c;
	return i;
}

int UnsignedToHex(unsigned v,char *s,char c)
{
	char *t = (char *)&v;
	int i = 0;

	++t;
	i += CharToHex(*t--,&s[i],0);
	i += CharToHex(*t,&s[i],c);
	return i;
}

void HexDump(int fd,char *b,int n)
{
	char *s = malloc(128);
	int i,j,l;
	unsigned adr;

	adr = (unsigned)b;

	for(j=0;j<n;j+=8)
	{
		l = 0;
		l += UnsignedToHex(adr,&s[l],' ');
		for(i=0;i<8;++i)
		{
			l += CharToHex(b[i+j],&s[l],(i==7)?' ':'-');
		}
		for(i=0;i<8;++i)
		{
			if(isprint(b[i+j]))
				s[l++] = b[i+j];
			else
				s[l++] = '.';
		}
		s[l++] = '\r';
		s[l++] = '\n';
		_write(fd,s,l);
		adr += 8;
	}
	free(s);
}
