/*!
 * \file CursesDev.h
 * Curses Device Driver...allows for use of FILE streams for sending data to a curses window
 *
 */

#ifndef CURSESDEV__H
#define CURSESDEV__H

#include <curses.h>

#define CURSESDEV_XIO_CREATEWINDOW	0	/*!< XIO Command:Create Window for open channel	*/

/*!
 * \struct _Wparams;
 * Pass structure to CioXio when using CURSESDEV_XIO_CREATEWINDOW command
 */
struct _Wparams {
 int xpos;		/*!< X position of window	*/
 int ypos;		/*!< Y position of window	*/
 int xsize;		/*!< X size of window	*/
 int ysize;		/*!< Y size of window	*/
 int fg;		/*!< forground color	*/
 int bg;		/*!< background color	*/
 int mode;		/*!< mode to open window in	*/
};

extern void CursesDevInit(void);
extern IOCB *CioAttatchWindow(char *devname,WINDOW *pW);
extern void InitWParams(struct _Wparams *pWP, int xpos,int ypos, int xsize,int ysize,int fg, int bg, int mode);

#endif
