/****************************************************************************
** These are a collection of routines that implement a simple timer service
**
** Created May 14, 2008
**
****************************************************************************/

#ifndef TIMERSERVICES__H
#define TIMERSERVICES__H

#include "task.h"

typedef struct tservice TSERVICE;

struct tservice{
	unsigned int Time;
	unsigned int Counter;
	unsigned int Mode;
	void *arg;
	void (*callback)(void *arg);
	TSERVICE *next,*prev;
};

extern ECB *TimerServicesSem;

extern TSERVICE *NewTimerService(unsigned t, unsigned m, void *arg, void (*cb)(void *) );
extern void DeleteTimerService(TSERVICE *pTS);
extern void StartTimer(TSERVICE *pTS);
extern void KillTimer(TSERVICE *pTS);
extern void InitTimerServices(void);

#endif
