/*****************************************************
** VGA display Driver
******************************************************/

#ifndef DISPLAY__H
#define DISPLAY__H

//-------------------------------------------------
// hardware interface
//-------------------------------------------------

#define VGA_BASE_ADDRESS	0xc000
#define VGA_CHARMEM			*((volatile unsigned short *)VGA_BASE_ADDRESS)
#define VGA_CHARMEM_P		((volatile unsigned short *)VGA_BASE_ADDRESS)
#define VGA_CHARGEN			*((volatile unsigned char *)(VGA_BASE_ADDRESS+0x2800))
#define VGA_CHARGEN_P		((volatile unsigned char *)(VGA_BASE_ADDRESS+0x2800))
#define VGA_COLOR_LUT		*((volatile unsigned char *)0xf010)
#define VGA_COLOR_LUT_P		((volatile unsigned char *)0xf010)
#define VGA_CONTROL_STATUS	*((volatile unsigned char *)0xf002)

//-------------------------------------------------
// Color Defines
//-------------------------------------------------

#define BLACK	0
#define RED		1
#define GREEN	2
#define YELLOW	3
#define BLUE	4
#define VIOLET	5
#define CYAN	6
#define WHITE	7

//--------------------------------------------------
// forground and background for attribute byte
//--------------------------------------------------

#define FG(x)	(x << 3)		/*!< Generate Forground Color	*/
#define BG(x)	(x)				/*!< Generate Background Color	*/

#ifndef BIT
#define BIT(x)		(1 << (x))
#endif

//--------------------------------------------------
// Function Prototypes
//--------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

extern void InitVGA(void);
extern void EnableVGAIrq(void);
extern void DisableVGAIrq(void);

#ifdef __cplusplus
}
#endif

#endif
