/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "task.h"
/*!
 *	\file DoSwap.c
 *	\ingroup MultitaskingKernel
 */

/*@{*/

/*!
 * \fn void DoSwap(void)
 * \brief Do a Context Switch
 *
 * This function does a context switch at the 'task' level. <br>
 * It should be noted, that before you call this function, NextTask
 * needs to be set to point to the Task Control Block (TCB) of the
 * thread that is going to run next.
 */

void DoSwap(void) __attribute__ ( ( naked ) );

void DoSwap(void)
{
	SAVE_CONTEXT();		//save the context of the current task
	CurrentTask = NextTask;	//set current task to next task
	RESTORE_CONTEXT();		//restore context of new task
}

/*@}*/
