/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// If in the future, a newer version (or older version for that matter) does not
// work properly, the code might have to be changed.  In particular, void IrqSwap(void)
//
// The following line in IrqSwap may need to be changed, in particular:
//		"adiw r24,6				\n\t"			//add 6 (remove irrelavent calls)
//
// This line adds 6 to the stack pointer, and depending on how much the compiler 
// pushes on stacks, this value could change.  For instance, to make the -O0 option
// work correctly, you need to change this value to 8
// /////////////////////////////////////////////////////////////////////////////////////////

#include "task.h"

void IrqSwap(void) __attribute__ ( ( naked ) );

void IrqSwap(void)
{
	//-----------------------------
	// next, we need to adjust
	// the size of the stack
	// ignore return addresses on
	// stack to IrqSwap and 
	// Exit Interrupt
	//-----------------------------
	asm volatile (
		"in r25,__SP_H__		\n\t"			//get the stack pointer
		"in r24,__SP_L__		\n\t"
		"adiw r24,6				\n\t"			//add 6 (remove irrelavent calls)
		"lds	r26, CurrentTask		\n\t"	//get address of current task
		"lds	r27, CurrentTask + 1	\n\t"
		"st		x+, r24					\n\t"	//save stack pointer in TCB
		"st		x+, r25					\n\t"
	);
	CurrentTask = NextTask;
	RESTORE_CONTEXT();				//restore next task context
}
