/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "task.h"

int TimeDelay(int mSec)
{
	//--------------------------------------------------------------------------
	// Delay task for a time
	//	parameters:
	//	mSec.............number of milliseconds to delay for
	//
	// return value:
	//	returns non zero value if something happened out of the ordinary
	//--------------------------------------------------------------------------
	int retval;
	static int DCount = 0;	//keeps track of the number of times its called
	ECB *e;					//pointer to event control block for semaphore
	char sr;					//save area for status register

	sr = Disable();			//disable interrupts
	char *s = malloc(32);	//get a new block of memory
	Enable(sr);				//bring interrupts back up
	s[0] = 'D';				//create name for semaphore
	itoa(DCount++,&s[1],10);
	e = NewSemaphore(0,SEMAPHORE_MODE_TIMEOUT,s);	//create semaphore
	sr = Disable();
	free(s);			//return memory block
	Enable(sr);
	retval = PendSemaphore(e,mSec);	//pend for time delay period
	DeleteSemaphore(e);				//return semaphore back to pool
	return retval;					//exit
}
