/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "task.h"
#include "pq.h"


volatile int TStamp;


extern PQ ActiveTasks;
extern ECB *TimeoutList;
static ECB *PostList;

/***********************************************************************
** TimerTicker                                                        **
**                                                                    **
**	This function is called by the real time interrupt handler        **
**	This function Increments the clock, scans through the Event       **
**  Control Blocks looking for timed out events.                      **
**                                                                    **
***********************************************************************/


void TimerTicker(void)
{
	//we need to process the list of tasks waiting
	//for queues
	ECB *e;
	TCB *t,**prev;


	++TStamp;
	for(e = TimeoutList;e;e=e->Tnext)	//go through whole list
	{
		for(prev = &(e->task_h),t = e->task_h;t;)
		{
			if(t->timeout > 0)	//if less than zero, infinate timeout
			{
				if( --(t->timeout) <= 0)	//decrement timeout counter
				{
					e->EventCount++;		//fake a post
					t->status = EVENT_TIMEOUT;	//event caused by semaphore
					*prev = t->next;
					t->next = 0;
					Insert(&ActiveTasks,t);
				}
			}
			prev = &(t->next);
			t = t->next;
		}
	}
	e = PostList;
	while(e)
	{
		PostSemaphore(e,0);
		e = e->Tnext;
	}
}

void RegisterTickerPost(ECB *pS)
{
	char sr;

	sr = Disable();
	pS->Tnext = PostList;
	PostList = pS;
	Enable(sr);
}
