/*************************************************************************
**	C version of CIO
**	Copyright (c) 1991 Jim Patchell
**
**	This is the Central Input Output device handler.  This is probably
**	a lame attempt to make access to various I/O devices a little more
**	orthagonal.  Maybe, maybe not.
**
**  The interface function, cio only requires one parameter, but accepts
**	a variable number of parameters depending on the type of function
**	it is that is being executed.
**
**	The functions that can be executed are:
**
**		add handler
**		open
**		close
**		get
**		get record (read)
**		put
**		put record (write)
**		status
**		special command (xio)
**
**
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fcntl.h"
#include "cio.h"
#include "task.h"

int CioPutC(IOCB *I,int c)
{
	/*
	** Put data to device
	**           : cio(PUTC,handle,data)
	*/
	if((I->mode & FCNTL_WRONLY) == 0)
		return(CIO_RDONLY);	/*	read only error	*/
	//
	//look up function
	//
	return( (*htabs[I->ichid].HtabsEntry->putv)(I,c));
}

int CioWrite(IOCB *I,char *b,int n)
{
	/*
	** Write buffer to a device
	**  called as: cio(WRITE,handle,buffer,count);
	** returns either an error or actual number of bytes written
	*/
	if((I->mode & FCNTL_WRONLY) == 0)
		return(CIO_RDONLY);	/*	read only error	*/
	return( (*htabs[I->ichid].HtabsEntry->writev)(I,b,n));
}
