// SynthConsolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SynthConsol.h"
#include "SynthConsolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SER_PORT_MODE_EXIT	0
#define SER_PORT_MODE_REOPEN 1


//---------------------------------------------------------------------------
// Serial Port Callback Function
//---------------------------------------------------------------------------

void SerialPortCallback(void *pV)
{
	CSynthDlg *pDlg = (CSynthDlg *)pV;
	int c;

	c = pDlg->pComPort->GetComPort();	//get a character from the comport
	pDlg->m_pSynthPort->ParseIncomingStream(c);
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSynthDlg dialog

CSynthDlg::CSynthDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSynthDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSynthDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_SerialPortMode = SER_PORT_MODE_EXIT;
	m_ComPort = 4;
	m_BaudRate = BR.GetBaudRateIndex(115200);
	mAckCount = 0;
	m_TestCommand_AutoResponse = 0;
	TCount = 0;
	m_pSynthDlg = 0;
	m_pLA = 0;
	m_pSingleStepDlg = 0;
}

void CSynthDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSynthDlg)
	DDX_Control(pDX, IDC_EDIT_ADDRESS, m_Edit_PeekAddress);
	DDX_Control(pDX, IDC_STATIC_PEEK, m_Static_Peek);
	DDX_Control(pDX, IDC_CHECK_ENABLE_SYNTH, m_Check_EnableSynth);
	DDX_Control(pDX, IDC_CHECK_AUTORESPONSE, m_Check_AutoResponse);
	DDX_Control(pDX, IDC_EDIT_TESTSTRING, m_Edit_TestString);
	DDX_Control(pDX, IDC_STATIC_DISP, m_Static_Display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSynthDlg, CDialog)
	//{{AFX_MSG_MAP(CSynthDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SERIAL_SETUP, OnButtonSerialSetup)
	ON_BN_CLICKED(IDC_BUTTON_TESTCMD, OnButtonTestcmd)
	ON_BN_CLICKED(IDC_CHECK_AUTORESPONSE, OnCheckAutoresponse)
	ON_BN_CLICKED(IDC_BUTTON_LOGIC_ANALYZER, OnButtonLogicAnalyzer)
	ON_BN_CLICKED(IDC_CHECK_ENABLE_SYNTH, OnCheckEnableSynth)
	ON_BN_CLICKED(IDC_BUTTON_SETUP_SYNTH, OnButtonSetupSynth)
	ON_BN_CLICKED(IDC_BUTTON_PEEK, OnButtonPeek)
	ON_BN_CLICKED(IDC_BUTTON_SINGLE_STEP, OnButtonSingleStep)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_COMMTHREAD_STOPPED,OnCommThreadStopped)
	ON_MESSAGE(WM_PARSE_COMPLETE,DecodePacket)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSynthDlg message handlers

BOOL CSynthDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here
	//-------------------------------------------------------
	// Open up the com port
	//-------------------------------------------------------
	char *s = new char[256];

	m_Heap = new CMyHeap(65768);	//64K of general heap.
	AMSGSetHeap(m_Heap);
	sprintf(s,"Heap Size = %d",m_Heap->HeapSizeFree());
	m_Static_Display.InitStringFifo(12);
	m_Static_Display.SetWindowText(s);

	m_BaudRate = theApp.GetProfileInt("COMPORT","BAUD",BR.GetBaudRateIndex(115200));
	m_ComPort = theApp.GetProfileInt("COMPORT","PORT",4);

	m_pMQ = new CMsgQueue(64);	//space for 64 messages
	m_pSingleStepMessage = new CMsgQueue(64);	//64 messages for single step dialog box
	sprintf(s,"Open Serial Port [InitDialog] %s @ %d",BR.GetComPortName(m_ComPort),BR.GetBaudRate(m_BaudRate));
	m_Static_Display.SetWindowText(s);
	OpenSerialPort(m_BaudRate,m_ComPort);
	m_Edit_TestString.SetWindowText("This is a TEST");
//	AckMsg = new CIntQueue(256);
//	SetTimer(1,20,NULL);
	delete[] s;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSynthDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSynthDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSynthDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSynthDlg::OnOK() 
{
	// TODO: Add extra validation here
	CWnd *wC;

	wC = GetFocus();					//get handle of control that generated message
	int id = wC->GetDlgCtrlID();		//get ID of control
	switch(id)							//parse the id
	{
		case IDOK:
			theApp.WriteProfileInt("COMPORT","BAUD",m_BaudRate);
			theApp.WriteProfileInt("COMPORT","PORT",m_ComPort);
			pComPort->StopPort();
			break;
		default:
			wC = GetNextDlgTabItem(wC);	//reset the focus
			wC->SetFocus();
			break;
	}
}

LRESULT CSynthDlg::OnCommThreadStopped(WPARAM wparam, LPARAM lparam)
{
	char *s = new char[256];

	pComPort->WorkerTerminate();
	switch(m_SerialPortMode)
	{
		case SER_PORT_MODE_EXIT:
			delete pComPort;
			CDialog::OnOK();
			break;
		case SER_PORT_MODE_REOPEN:
			sprintf(s,"Recopen Serial Port [OnCommThreadStopped] %s @ %d",BR.GetComPortName(m_ComPort),BR.GetBaudRate(m_BaudRate));
			m_Static_Display.SetWindowText(s);
			m_SerialPortMode = SER_PORT_MODE_EXIT;
			OpenSerialPort(m_BaudRate,m_ComPort);
			break;
	}
	delete[] s;
	return 0;
}

int CSynthDlg::OpenSerialPort(int BRate, int ComPort)
{
	//------------------------------------------------
	// Do all the things we need to do to open up
	// and start a com port
	// parameters:
	//	BRate.......BaudRate (this is an index value)
	//				Object BaudRate is used to find
	//				this index from the real baudrate
	//	ComPort.....Com port index
	//				0 => COM1
	//				1 => COM2
	//				etc
	//
	// return value
	//	returns 0 on success
	//	returns non-zero on failure
	//------------------------------------------------
	int retval = 0;
	pComPort = new COverlappedSerial(BR.GetComPortName(ComPort) );	//create com port
	if(pComPort->StartPort(100,BRate,WM_COMMTHREAD_STOPPED,WM_COMMTHREAD_CHARIN,this->m_hWnd))
	{
		char *s = new char[256];
		sprintf(s,"Could not open Com Port %s\nError=%d",pComPort->GetPortName(),pComPort->ErrorNumber);
		MessageBox(s,"Comm Port Error",MB_OK | MB_ICONHAND);
		delete[] s;
		//we have an error....delete pComPort and set to NULL
		delete pComPort;
		pComPort = NULL;
		retval = 1;
	}
	if(pComPort)
	{
		pComPort->SetCharInCallback(SerialPortCallback,(void *)this);
		m_pSynthPort = new CSynthPort();
		m_pSynthPort->SetComPort(pComPort);
		m_pSynthPort->SetParseCompleteMessage(m_hWnd,WM_PARSE_COMPLETE);
		m_pSynthPort->SetMessageQueue(m_pMQ);
	}
	return retval;
}

void CSynthDlg::OnButtonSerialSetup() 
{
	// TODO: Add your control notification handler code here
	CSerialSetup nDlgSerSU;
	int iD;
	char *s = new char[256];

	nDlgSerSU.m_BaudRate = m_BaudRate;
	nDlgSerSU.m_ComPort = m_ComPort;
	iD = nDlgSerSU.DoModal();
	if(iD == IDOK)
	{
		m_BaudRate = nDlgSerSU.m_BaudRate;
		m_ComPort = nDlgSerSU.m_ComPort;
		if(pComPort)
		{
			sprintf(s,"Reopen Serial Port COM%d",m_ComPort+1);
			m_Static_Display.SetWindowText(s);
			m_SerialPortMode = SER_PORT_MODE_REOPEN;	//set mode to reopen serial port
			pComPort->StopPort();						//stop serial port thread
		}
		else
		{
			sprintf(s,"Just Open Serial Port COM%d",m_ComPort+1);
			m_Static_Display.SetWindowText(s);
			OpenSerialPort(m_BaudRate,m_ComPort);
		}
	}
	delete[] s;
}


void CSynthDlg::HexDump(CDisplayStatic *disp, char *m, int n)
{
	char *s = new char[2048];

	int i,j,l;

	for(l=0,i=0;i<n;i = i+8)
	{
		l = sprintf(s,"%04x:",i);
		for(j=0;j<8;++j) l += sprintf(&s[l],"%02x%c",m[i+j] & 0x0ff,(j==7)?' ':'-');
		for(j=0;j<8;++j) l += sprintf(&s[l],"%c",isprint(m[i+j])?m[i+j]:'.');
		disp->SetWindowText(s);
	}
	delete[] s;
}

int CSynthDlg::ParseMessage(AMSG *msg)
{
	int cmd = msg->MsgCmd;

	switch(cmd)
	{
		case MM_OUT_ACK:		//ACK
			{
				char *s = new char[256];
				++mAckCount;
				sprintf(s,"ACK : %d  Heap Free:%d  Payload=%d",mAckCount,m_Heap->HeapSizeFree(),msg->PayloadSize);
				m_Static_Display.SetWindowText(s);
				delete[] s;
				ParseAckMessage(msg->Payload,msg->PayloadSize);
//				if(AckMsg->Status())
//				{
//					PostMessage(AckMsg->Get());
//				}
			}
			break;
		case MM_OUT_NAK:		//NAK
			break;
	}
	return 0;
}

int CSynthDlg::ParseAckMessage(char *s, int n)
{
	unsigned short msg;
	unsigned char Status;

	unsigned short *pUS;
	unsigned long *pUL;
	unsigned short nUS;

	msg = *(unsigned short*)&s[0];
	Status = s[2];
	switch(msg)
	{
		case MM_TEST:
			s[40] = 0;
			m_Static_Display.SetWindowText(&s[3]);
			if(m_TestCommand_AutoResponse)
			{
				Sleep(20);
				OnButtonTestcmd();	//send it again..SAM
			}
			break;
		case MM_ARM_LA:	//				3
			m_Static_Display.SetWindowText("Logic Analyzer Armed");
			break;
		case MM_READ_LA:	//			4
			//---------------------------------------------
			// the data packet that comes back has the
			// following format:
			// b[1:0] <= Number of bytes
			// b[5:2] <= first long
			// etc...
			//
			// The first byte of the packet is located
			// at index 3 of "s"
			//----------------------------------------------
			pUS = (unsigned short *)&s[3];
			{
				char *d = new char[256];
				AMSG *pMsg;

				if(m_pLA)	//is there a logic analyzer dialog?
				{
					if(m_pLA->m_pMQ)	//is there a message queue?
					{
						pMsg = CreateAMSG(*pUS * sizeof(long),&s[5],MM_READ_LA);
						m_pLA->m_pMQ->Insert(pMsg);	//add message to queue
						m_pLA->PostMessage(WM_LA_DATA);
					}
				}
				sprintf(d,"READ_LA:n=%d",*pUS);
				m_Static_Display.SetWindowText(d);
				HexDump(&m_Static_Display,s,38);
				delete[] d;
			}
			break;
		case MM_SET_LA_TRIG:
			{
				char *d = new char[256];
				sprintf(d,"Got Set La Trig ACK");
				m_Static_Display.SetWindowText(d);
				delete[] d;
			}
			break;
		case MM_GET_OSC_FREQ:
			if(m_pSynthDlg)
			{
				HexDump(&m_Static_Display,s,16);
				pUS = (unsigned short *)&s[3];
				pUL = (unsigned long *)&s[5];
				m_pSynthDlg->PostMessage(WM_OSCFREQ,*pUS,*pUL);
			}
			break;
		case MM_RESET_LA:
			m_Static_Display.SetWindowText("Logic Analyzer Reset");
			break;
		case MM_STATUS_LA:
			{
				LA_STATUS *pSTS = (LA_STATUS *)&s[3];
				char *d = new char[256];
				sprintf(s,"Write = %d  Read = %d  State = %d",pSTS->WordsWritten,pSTS->BytesRead,pSTS->State);
				m_Static_Display.SetWindowText(s);
				delete [] d;
			}
			break;
		case MM_SETQUAL_LA:
			m_Static_Display.SetWindowText("Logic Analyzer Qualifier Set");
			break;
		case MM_GETQUAL_LA:
			{
				pUS = (unsigned short *)&s[3];
				char *d = new char[256];
				sprintf(s,"Qualifier = %d",*pUS);
				m_Static_Display.SetWindowText(s);
				delete [] d;
			}
			break;
		case MM_PEEK:
			{
				nUS = (unsigned short)(unsigned char)s[3];
				char *d = new char[256];
				sprintf(s,"%02x",nUS & 0x0ff);
				m_Static_Peek.SetWindowText(s);
				delete[] d;
			}
			break;
		case MM_SINGLESTEP:
			if(m_pSingleStepDlg) m_pSingleStepDlg->PostMessage(WM_SS_STEPED,0,0);
			break;
		case MM_GETDEBUG:
			if(m_pSingleStepDlg)
			{
				AMSG *pM = CreateAMSG(sizeof(SYNTH_DEBUG),&s[3],MM_GETDEBUG);
				m_pSingleStepMessage->Insert(pM);
				m_pSingleStepDlg->PostMessage(WM_SS_DEBUGDATA,0,0);
			}
			break;
		case MM_SET_SSCHANNEL:
			{
				char *d = new char[256];
				sprintf(d,"ACK Single Step Channel = %d",*(unsigned short *)&s[3]);
				m_Static_Display.SetWindowText(d);
				delete[] d;
			}
			break;
		default:
			{
				char *d = new char[256];
				sprintf(d,"Unkwown ACK:%d",msg);
				m_Static_Display.SetWindowText(d);
				delete[] d;
			}
			break;
	}
	return 0;
}

void CSynthDlg::OnButtonTestcmd() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Edit_TestString.GetWindowText(s,256);
	char *d = new char[256];
	sprintf(d,"%s %04d",s,TCount++);
	m_pSynthPort->SendTest(d);
	delete[] d;
	delete[] s;
}

void CSynthDlg::OnCheckAutoresponse() 
{
	// TODO: Add your control notification handler code here
	m_TestCommand_AutoResponse = m_Check_AutoResponse.GetCheck();
	m_TestCommand_AutoResponse ^= 1;		//flip state
	m_Check_AutoResponse.SetCheck(m_TestCommand_AutoResponse);
}

LRESULT CSynthDlg::DecodePacket(WPARAM wparam, LPARAM lparam)
{
	AMSG *msg = m_pMQ->Remove();		//get message packet
	if(msg)
	{
		ParseMessage(msg);
		m_Heap->Free(msg);
	}
	return 0;
}

void CSynthDlg::OnButtonLogicAnalyzer() 
{
	// TODO: Add your control notification handler code here
	if(!m_pLA)
	{
		m_pLA = new CLogicAnl;
		m_pLA->pSP = m_pSynthPort;
		m_pLA->Create(IDD_DIALOG_LA);
	}
	m_pLA->ShowWindow(1);
}

void CSynthDlg::OnCheckEnableSynth() 
{
	// TODO: Add your control notification handler code here
	int v = m_Check_EnableSynth.GetCheck();
	v ^= 1;
	m_Check_EnableSynth.SetCheck(v);
	m_pSynthPort->SendSynthEnable(v);
}

void CSynthDlg::OnButtonSetupSynth() 
{
	// TODO: Add your control notification handler code here
	if(m_pSynthDlg == NULL)
	{
		m_pSynthDlg = new CSynth;
		m_pSynthDlg->m_pSynthPort = m_pSynthPort;
		m_pSynthDlg->Create(IDD_DIALOG_SYNTH_SETUP);
	}
	m_pSynthDlg->ShowWindow(1);
}

void CSynthDlg::OnButtonPeek() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Edit_PeekAddress.GetWindowText(s,256);
	unsigned short address = (unsigned short)strtoul(s,NULL,16);
	m_pSynthPort->SendPeek(address);
	delete[] s;
}


void CSynthDlg::OnButtonSingleStep() 
{
	// TODO: Add your control notification handler code here
	if(m_pSingleStepDlg == NULL)
	{
		m_pSingleStepDlg = new CSingleStep;
		m_pSingleStepDlg->m_pSingleStepMessage = m_pSingleStepMessage;
		m_pSingleStepDlg->m_pSP = m_pSynthPort;
		m_pSingleStepDlg->Create(IDD_DIALOG_SINGLESTEP);
		m_pSingleStepDlg->ShowWindow(1);
	}
	else
		m_pSingleStepDlg->ShowWindow(1);
}
