`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    21:15:10 09/29/2008 
// Design Name: 
// Module Name:    MathTest 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module MathTest(clk, reset, Din, Dout, wd, A);
    input clk;
    input reset;
    input [7:0] Din;
    output [7:0] Dout;
    input wd;
    input [3:0] A;

	reg [7:0] Dout;
	
	parameter ADR_A_LO		=		3'b000;
	parameter ADR_A_HI		=		3'b001;
	parameter ADR_F_LO		=		3'b010;
	parameter ADR_F_HI		=		3'b011;
	parameter ADR_Z_LO		=		3'b100;
	parameter ADR_Z_HI		=		3'b101;
	parameter ADR_CMD			=		3'b111;
	
	reg [31:0]Z;
	reg [15:0] F,I;
	reg cmdEN,cmdRST;
	wire [31:0] Sum;
	wire [33:0] FreqO;
	wire [16:0] DiffO;
	
	reg wdAL,wdAH,wdFL,wdFH;

	always @ (A or Z or F or I) begin
		case(A)
			4'b0000: Dout = I[7:0];
			4'b0001: Dout = I[15:8];
			4'b0010: Dout = F[7:0];
			4'b0011: Dout = F[15:8];
			4'b0100: Dout = Z[7:0];
			4'b0101: Dout = Z[15:8];
			4'b0110: Dout = Z[23:16];
			4'b0111: Dout = Z[31:24];
			4'b1000: Dout = DiffO[7:0];
			4'b1001: Dout = DiffO[15:8];
			4'b1100: Dout = FreqO[7:0];
			4'b1101: Dout = FreqO[15:8];
			4'b1110: Dout = FreqO[23:16];
			4'b1111: Dout = FreqO[31:24];
			default: Dout = 8'b0;
		endcase
	end
	
	always @ (A or wd or Din)
		if((A == ADR_CMD) && wd && Din[1])
			cmdRST = 1;
		else
			cmdRST = 0;

	always @ (A or wd or Din)
		if((A == ADR_CMD) && wd && Din[0])
			cmdEN = 1;
		else
			cmdEN = 0;

	always @ (A or wd)
		if((A == ADR_F_HI) && wd)
			wdFH = 1;
		else
			wdFH = 0;

	always @ (A or wd)
		if((A == ADR_F_LO) && wd)
			wdFL = 1;
		else
			wdFL = 0;
			
	always @ (A or wd)
		if((A == ADR_A_HI) && wd)
			wdAH = 1;
		else
			wdAH = 0;

	always @ (A or wd)
		if((A == ADR_A_LO) && wd)
			wdAL = 1;
		else
			wdAL = 0;
	
	always @(posedge clk or posedge reset)
		if(reset)
			I <= 0;
		else if (wdAL)
			I[7:0] <= Din;
		else if (wdAH)
			I[15:8] <= Din;
			
	always @(posedge clk or posedge reset)
		if(reset)
			F <= 0;
		else if (wdFL)
			F[7:0] <= Din;
		else if (wdFH)
			F[15:8] <= Din;

	always @ (posedge clk or posedge reset)
		if(reset)
			Z <= 0;
		else if (cmdRST)
			Z <= 0;
		else if (cmdEN)
			Z <= Sum;

/*--------------------
input [31 : 0] A;
input [31 : 0] B;
output [31 : 0] S;
---------------------*/

Adder32 Zd(
	.A(FreqO[31:0]),
	.B(Z),
	.S(Sum)
);


 
 
// The following must be inserted into your Verilog file for this
// core to be instantiated. Change the instance name and port connections
// (in parentheses) to your own signal names.
 
MultS17x17 FreqCtl2 (
    .clk(clk),
    .a(DiffO), // Bus [16 : 0] 
    .b({1'b0,F}), // Bus [16 : 0] 
    .p(FreqO)); // Bus [33 : 0] 

 
		
					

/*
  input clk;
  input [15 : 0] a;	//signed input
  input [15 : 0] b;	//unsigned input
  output [31 : 0] p;	//product
*/

/*

MultSAUB16 FreqCtl(
	.clk(clk),
	.a(DiffO[15:0]),
	.b(F),
	.p(FreqO)
);
*/
/*
input [15 : 0] A;
input [15 : 0] B;
output [15 : 0] S;
A - B = S
*/

assign DiffO = {1'b0,I} - {1'b0,Z[31:16]};
/*
Subtractor16 Diff(
	.A(I),
	.B(Z[31:16]),
	.S(DiffO)
);
*/

endmodule
