`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:22:32 09/25/2008 
// Design Name: 
// Module Name:    SingleStep 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module SingleStep(clk, reset, D, S, Ein, Eo);
    input clk;			//system clock
    input reset;		//system reset
    input D;			//cycle done
    input S;			//start single step
    input Ein;			//enable input
    output Eo;			//enable output

	wire Eo;
	
	reg[1:0] CS,NS;
	assign Eo = CS[0];
	
	always @ (posedge clk or posedge reset)
		if(reset)
			CS <= 0;
		else
			CS <= NS;
			
	always @ (CS or D or S or Ein) begin
		case (CS)
			2'b00: begin
				if(S)
					NS = 2'b11;
				else if (Ein)
					NS = 2'b01;
				else
					NS = 2'b00;
			end
			2'b01: begin
				if(Ein == 0)
					NS = 2'b00;
				else
					NS = 2'b01;
			end
			2'b11: begin
				if(D)
					NS = 2'b00;
				else
					NS = 2'b11;
			end
			default: NS = 2'b00;
		endcase
	end

endmodule
