////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 9.1.01i
//  \   \         Application : ISE
//  /   /         Filename : muart_tb.tfw
// /___/   /\     Timestamp : Thu Feb 08 09:34:55 2007
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: muart_tb_tb_0
//Device: Xilinx
//
`timescale 1ns/1ps

module muart_tb_tb_0;
    reg clk = 1'b0;
    reg reset = 1'b0;
    reg [7:0] D = 8'b00000000;
    wire [7:0] O;
    reg [2:0] A = 3'b000;
    reg wd = 1'b0;
    reg rd = 1'b0;
    wire [3:0] I;
    reg rxd = 1'b0;
    wire txd;

    parameter PERIOD = 20;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 10;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    muart UUT (
        .clk(clk),
        .reset(reset),
        .D(D),
        .O(O),
        .A(A),
        .wd(wd),
        .rd(rd),
        .I(I),
        .rxd(rxd),
        .txd(txd));

    initial begin
        // -------------  Current Time:  10ns
        #10;
        reset = 1'b1;
        // -------------------------------------
        // -------------  Current Time:  38ns
        #28;
        reset = 1'b0;
        // -------------------------------------
        // -------------  Current Time:  58ns
        #20;
        A = 3'b011;
        // -------------------------------------
        // -------------  Current Time:  78ns
        #20;
        wd = 1'b1;
        // -------------------------------------
        // -------------  Current Time:  98ns
        #20;
        wd = 1'b0;
        // -------------------------------------
        // -------------  Current Time:  138ns
        #40;
        D = 8'b01000000;
        A = 3'b100;
        // -------------------------------------
        // -------------  Current Time:  158ns
        #20;
        wd = 1'b1;
        // -------------------------------------
        // -------------  Current Time:  178ns
        #20;
        wd = 1'b0;
        // -------------------------------------
        // -------------  Current Time:  218ns
        #40;
        D = 8'b01010101;
        A = 3'b000;
        // -------------------------------------
        // -------------  Current Time:  238ns
        #20;
        wd = 1'b1;
        // -------------------------------------
        // -------------  Current Time:  258ns
        #20;
        wd = 1'b0;
        // -------------------------------------
    end

endmodule

